
function Barrier(n, color, angle)
{
	this.node = n;
	this.color = color;
	this.angle = angle;
	this.hp = 400;
	this.offset = new Vector2();

	this.node.barrier = this;
	
	this.attack = function(color)
	{
		if (this.color == 4 || this.color == color)
		{
			this.offset.x += 2 * (Math.random() - 0.5);
			this.offset.y += 2 * (Math.random() - 0.5);

			if ((--this.hp) <= 0)
				this.node.barrier = null;
		}
	}

	this.update = function()
	{
		this.offset.x = 0;
		this.offset.y = 0;
	}

	this.destroyed = function()
	{
		return (this.hp <= 0);
	}

	this.render = function()
	{
		var renderpos = new Vector2(this.node.pos);
		renderpos.add(this.offset);
		Global.render(Content.barriers[color], renderpos, this.angle);
	}
}
