
function Carried()
{
	this.update = function()
	{
	}

	this.carry = function(dude)
	{
		if (this.carried)
			return false;

		this.carrying.push(dude);
		
		if (this.lifted())
		{
			// Count how many of each color is carrying the token.
			var colors = [0,0,0,0];
			for (var i = 0; i < this.carrying.length; i++)
				colors[this.carrying[i].type]++;

			var maxcount = 0;
			for (var i = 3; i >= 0; i--)
			{
				if (colors[i] > maxcount)
				{
					this.color = i;
					maxcount = colors[i];
				}
			}

			this.carried = true;
		}

		return true;
	}
	
	this.putdown = function(dude)
	{
		this.carrying.splice(this.carrying.indexOf(dude), 1);
	}

	this.lifted = function()
	{
		return this.carrying.length >= this.value;
	}

	this.returned = function()
	{
		return (this.carried && this.carrying.length == 0);
	}

	this.currentPos = function()
	{
		if (this.carried)
		{
			var pos = new Vector2();

			// Take the average position of all the dudes carrying the token.
			for (var i = 0; i < this.carrying.length; i++)
			{
				pos.add(this.carrying[i].currentPos());
			}

			pos.divide(this.carrying.length);
			return pos;
		}
		else
		{
			var pos = new Vector2(this.node.pos);
			pos.add(this.offset);
			return pos;
		}
	}
}
