
function Vector2(x, y)
{
	if (arguments.length == 0)
	{
		this.x = 0;
		this.y = 0;
	}
	else if (arguments.length == 1)
	{
		this.x = x.x;
		this.y = x.y;
	}
	else
	{
		this.x = x;
		this.y = y;
	}
}

Vector2.prototype.add = function(v0)
{
	this.x += v0.x;
	this.y += v0.y;
}

Vector2.prototype.subtract = function(v0)
{
	this.x -= v0.x;
	this.y -= v0.y;
}

Vector2.prototype.multiply = function(val)
{
	this.x *= val;
	this.y *= val;
}

Vector2.prototype.divide = function(val)
{
	this.x /= val;
	this.y /= val;
}
