
function Enemy(n, color)
{
	this.node = n;
	this.color = color;
	this.hp = 1000;
	this.offset = new Vector2();

	this.node.enemy = this;
	
	this.attack = function(color)
	{
		this.offset.x += 2 * (Math.random() - 0.5);
		this.offset.y += 2 * (Math.random() - 0.5);

		if (this.color == 4 || this.color == color)
		{
			if ((this.hp -= 3) <= 0)
				this.node.enemy = null;

			return (Math.random() < 0.008);
		}
		else
		{
			if ((this.hp -= 1) <= 0)
				this.node.enemy = null;
				
			return (Math.random() < 0.01);
		}
	}

	this.update = function()
	{
		this.offset.x = 0;
		this.offset.y = 0;
	}

	this.destroyed = function()
	{
		return (this.hp <= 0);
	}

	this.render = function()
	{
		var renderpos = new Vector2(this.node.pos);
		renderpos.add(this.offset);
		var frame = Math.floor(ticker / 20) % 2;
		Global.render(Content.enemy[this.color][frame], renderpos, this.angle);
	}
}
