
function Level0()
{
	this.init();

	this.background = new Image();
	this.background.src = "gfx/level0.png";

	Global.path = new Path();
	
	// Start
	var nbase = this.newNode(512, 664);
	var ncross = this.newNode(510, 572, nbase);

	// Left prong
	var left0 = this.newNode(295, 569, ncross);
	var left1 = this.newNode(159, 578, left0);
	var left2 = this.newNode(159, 370, left1);
	var left3 = this.newNode(159, 177, left2);

	// Right prong
	var right0 = this.newNode(919, 573, ncross);
	var right1 = this.newNode(914, 182, right0);

	// Middle prong
	var mid0 = this.newNode(506, 250, ncross);
	var mid1 = this.newNode(506, 185, mid0);

	Global.basenode = nbase;
	this.spawnPeeps();

	this.barriers.push(new Barrier(mid0, 0, 0));
	
	this.goal = new Goal(mid1);

	this.tokens.push(new Token(left2, 1));
	this.tokens.push(new Token(left2, 1));
	this.tokens.push(new Token(left2, 1));
	this.tokens.push(new Token(left3, 3));
	this.tokens.push(new Token(left3, 5));
	this.tokens.push(new Token(right1, 3));
	this.tokens.push(new Token(right1, 5));
}

Level0.prototype = new Level();
