
function Level1()
{
	this.init();

	this.background = new Image();
	this.background.src = "gfx/level1.png";

	Global.path = new Path();
	
	var centre = this.newCircle(510, 380);

	var left0 = this.newNode(504, 88, centre[1]);
	var left1 = this.newNode(284, 90, left0);
	var left2 = this.newNode(94, 90, left1);

	var left3 = this.newNode(100, 240, left2);
	var left4 = this.newNode(100, 460, left3);
	var left5 = this.newNode(100, 662, left4);
	
	var left6 = this.newNode(290, 530, left5, centre[6]);

	var clearing = this.newCircle(687, 592);
	var clearroute = this.newNode(604, 476, centre[4], clearing[8]);

	var right0 = this.newNode(776, 376, centre[3]);
	var right1 = this.newNode(914, 380, right0);

	var rightup0 = this.newNode(912, 280, right1);
	var rightup1 = this.newNode(912, 180, rightup0);
	var rightup2 = this.newNode(912, 82, rightup1);

	var rightdown0 = this.newNode(912, 520, right1);
	var rightdown1 = this.newNode(910, 644, rightdown0);

	Global.basenode = centre[0];
	this.spawnPeeps();
	
	this.barriers.push(new Barrier(left1, 0, Math.PI / 2));
	this.barriers.push(new Barrier(left6, 1, Math.PI / 4));
	this.barriers.push(new Barrier(clearroute, 0, -Math.PI / 4));
	this.barriers.push(new Barrier(rightup0, 0, 0));
	this.barriers.push(new Barrier(rightup1, 1, 0));
	
	this.enemies.push(new Enemy(left2, 1));
	this.enemies.push(new Enemy(left5, 0));

	this.goal = new Goal(left3);
	
	this.tokens.push(new Token(centre[2], 1));
	this.tokens.push(new Token(centre[5], 1));
	this.tokens.push(new Token(centre[8], 1));
	
	this.tokens.push(new Token(clearing[0], 5));
	this.tokens.push(new Token(clearing[2], 3));
	this.tokens.push(new Token(clearing[5], 1));
	this.tokens.push(new Token(clearing[6], 1));
	
	this.tokens.push(new Token(rightup2, 5));
	this.tokens.push(new Token(rightup2, 3));
	this.tokens.push(new Token(rightdown1, 5));
}

Level1.prototype = new Level();
