
function Level2()
{
	this.init();

	this.background = new Image();
	this.background.src = "gfx/level2.png";

	Global.path = new Path();
	
	var start = this.newCircle(182, 548);
	
	var straight0 = this.newNode(340, 558, start[3]);
	var straight01 = this.newNode(472, 556, straight0);
	var straight1 = this.newNode(552, 556, straight01);
	var straight2 = this.newNode(676, 552, straight1);
	var straight3 = this.newNode(798, 554, straight2);
	var straight4 = this.newNode(862, 554, straight3);
	var straight5 = this.newNode(942, 554, straight4);

	var startup0 = this.newNode(184, 400, start[1]);
	var startup1 = this.newNode(184, 340, startup0);
	var startup2 = this.newNode(184, 126, startup1);

	var middle0 = this.newNode(546, 330, straight1);
	var middle1 = this.newNode(544, 128, straight1);

	var top0 = this.newNode(88, 126, startup2);
	var top1 = this.newNode(330, 128, startup2);
	var top2 = this.newNode(400, 128, top1, middle1);
	var top3 = this.newNode(622, 128, middle1);

	var end = this.newCircle(792, 305);
	var endroute = this.newNode(796, 468, end[5], straight3);


	Global.basenode = start[0];
	this.spawnPeeps();
	
	this.barriers.push(new Barrier(straight0, 2, Math.PI / 2));
	this.barriers.push(new Barrier(straight01, 1, Math.PI / 2));
	this.barriers.push(new Barrier(top1, 0, Math.PI / 2));
	this.barriers.push(new Barrier(top2, 1, Math.PI / 2));
	this.barriers.push(new Barrier(straight4, 2, Math.PI / 2));
	
	this.enemies.push(new Enemy(startup0, 0));
	this.enemies.push(new Enemy(startup1, 1));
	this.enemies.push(new Enemy(straight2, 0));
	this.enemies.push(new Enemy(endroute, 1));

	this.goal = new Goal(end[0]);
	
	this.tokens.push(new Token(top0, 1));
	this.tokens.push(new Token(top0, 1));
	this.tokens.push(new Token(top0, 1));
	
	this.tokens.push(new Token(top3, 3));
	this.tokens.push(new Token(top3, 5));
	this.tokens.push(new Token(top3, 1));
	
	this.tokens.push(new Token(straight5, 5));
	this.tokens.push(new Token(straight5, 5));
	
	this.tokens.push(new Token(end[2], 3));
	this.tokens.push(new Token(end[4], 3));
	this.tokens.push(new Token(end[7], 3));
	this.tokens.push(new Token(end[8], 5));
}

Level2.prototype = new Level();
