
function Level3()
{
	this.init();

	this.background = new Image();
	this.background.src = "gfx/level3.png";

	Global.path = new Path();
	
	var centre = this.newCircle(512, 360);
	var top = this.newCircle(512, 120);
	var bottom = this.newCircle(512, 600);
	var left = this.newCircle(160, 360);
	var right = this.newCircle(860, 360);
	
	var top0 = this.newNode(512, 240, centre[1], top[5]);
	var bottom0 = this.newNode(512, 480, centre[5], bottom[1]);
	var left0 = this.newNode(380, 360, centre[7]);
	var left1 = this.newNode(330, 360, left0);
	var left2 = this.newNode(280, 360, left1, left[3]);
	var right0 = this.newNode(640, 360, centre[3]);
	var right1 = this.newNode(690, 360, right0);
	var right2 = this.newNode(740, 360, right1, right[7]);

	var leftup0 = this.newNode(160, 240, left[1]);
	var leftup1 = this.newNode(160, 180, leftup0);
	var leftup2 = this.newNode(160, 120, leftup1);
	
	var bottomright0 = this.newNode(640, 600, bottom[3]);
	var bottomright1 = this.newNode(750, 600, bottomright0);
	var bottomright2 = this.newNode(860, 600, bottomright1);
	var bottomright3 = this.newNode(860, 540, bottomright2);
	var bottomright4 = this.newNode(860, 480, bottomright3, right[5]);

	Global.basenode = top[0];
	this.spawnPeeps();
	
	this.barriers.push(new Barrier(left0, 0, Math.PI / 2));
	this.barriers.push(new Barrier(left1, 1, Math.PI / 2));
	this.barriers.push(new Barrier(left2, 2, Math.PI / 2));
	this.barriers.push(new Barrier(leftup0, 3, 0));

	this.barriers.push(new Barrier(right0, 4, Math.PI / 2));
	
	this.enemies.push(new Enemy(centre[0], 1));
	this.enemies.push(new Enemy(right1, 2));
	this.enemies.push(new Enemy(right2, 0));
	this.enemies.push(new Enemy(left[1], 1));
	
	this.goal = new Goal(leftup1);

	this.tokens.push(new Token(top[3], 1));
	this.tokens.push(new Token(top[4], 3));
	this.tokens.push(new Token(top[6], 1));
	
	this.tokens.push(new Token(left[4], 3));
	this.tokens.push(new Token(left[5], 5));
	this.tokens.push(new Token(left[8], 3));

	this.tokens.push(new Token(leftup2, 5));
	
	this.tokens.push(new Token(bottom[0], 5));
	
	this.tokens.push(new Token(right[0], 10));
	this.tokens.push(new Token(right[2], 5));
	this.tokens.push(new Token(right[4], 5));
	this.tokens.push(new Token(right[7], 3));
}

Level3.prototype = new Level();
