
function Level4()
{
	this.init();

	this.background = new Image();
	this.background.src = "gfx/level4.png";

	Global.path = new Path();
	
	var centre = this.newCircle(560, 360);
	var start = this.newCircle(160, 360);
	
	var middle0 = this.newNode(280, 360, start[3]);
	var middle1 = this.newNode(360, 360, middle0);
	var middle2 = this.newNode(440, 360, middle1, centre[7]);
	
	var middle3 = this.newNode(680, 360, centre[3]);
	var middle4 = this.newNode(740, 360, middle3);
	var middle5 = this.newNode(800, 360, middle4);
	var middle6 = this.newNode(860, 360, middle5);

	var bottom0 = this.newNode(252, 452, start[4]);
	var bottom1 = this.newNode(322, 514, bottom0);
	var bottom2 = this.newNode(430, 600, bottom1);
	var bottom3 = this.newNode(480, 600, bottom2);
	var bottom4 = this.newNode(560, 600, bottom3);
	
	var bottom5 = this.newNode(620, 600, bottom4);
	var bottom6 = this.newNode(700, 600, bottom5);
	var bottom7 = this.newNode(780, 600, bottom6);
	var bottom8 = this.newNode(860, 600, bottom7);
	
	var bottom9 = this.newNode(860, 520, bottom8);
	var bottom10 = this.newNode(860, 440, bottom9, middle6);

	var bottomjoin0 = this.newNode(560, 540, bottom4);
	var bottomjoin1 = this.newNode(560, 480, bottomjoin0, centre[5]);
	
	var top0 = this.newNode(252, 720 - 452, start[2]);
	var top1 = this.newNode(338, 196, top0);
	var top2 = this.newNode(430, 720 - 600, top1);
	var top3 = this.newNode(480, 720 - 600, top2);
	var top4 = this.newNode(560, 720 - 600, top3);
	
	var top5 = this.newNode(620, 720 - 600, top4);
	var top6 = this.newNode(700, 720 - 600, top5);
	var top7 = this.newNode(780, 720 - 600, top6);
	var top8 = this.newNode(860, 720 - 600, top7);
	
	var top9 = this.newNode(860, 720 - 520, top8);
	var top10 = this.newNode(860, 720 - 440, top9, middle6);
	
	var topbit0 = this.newNode(306, 160, top1);
	var topbit1 = this.newNode(258, 122, topbit0);
	var topbit2 = this.newNode(210, 78, topbit1);

	Global.basenode = start[0];
	this.spawnPeeps();
	
	this.barriers.push(new Barrier(middle1, 0, Math.PI / 2));
	this.barriers.push(new Barrier(middle2, 2, Math.PI / 2));
	this.barriers.push(new Barrier(middle4, 2, Math.PI / 2));
	
	this.barriers.push(new Barrier(top6, 3, Math.PI / 2));
	this.barriers.push(new Barrier(topbit0, 1, -Math.PI / 4));
	
	this.barriers.push(new Barrier(bottom2, 1, -1));
	
	this.enemies.push(new Enemy(top0, 4));
	this.enemies.push(new Enemy(middle0, 4));
	this.enemies.push(new Enemy(bottom0, 4));
	
	this.enemies.push(new Enemy(centre[7], 3));
	this.enemies.push(new Enemy(centre[3], 1));
	this.enemies.push(new Enemy(middle3, 3));
	this.enemies.push(new Enemy(middle5, 3));
	
	this.enemies.push(new Enemy(top1, 2));
	this.enemies.push(new Enemy(top2, 2));
	this.enemies.push(new Enemy(top3, 1));
	this.enemies.push(new Enemy(top5, 2));
	this.enemies.push(new Enemy(top7, 4));
	this.enemies.push(new Enemy(top8, 4));
	this.enemies.push(new Enemy(top9, 4));
	this.enemies.push(new Enemy(top10, 4));
	
	this.enemies.push(new Enemy(bottom1, 1));
	this.enemies.push(new Enemy(bottom3, 0));
	
	this.enemies.push(new Enemy(bottom5, 0));
	this.enemies.push(new Enemy(bottom6, 0));
	this.enemies.push(new Enemy(bottom7, 0));
	this.enemies.push(new Enemy(bottom8, 0));
	this.enemies.push(new Enemy(bottom9, 2));
	
	this.goal = new Goal(middle6);
	
	this.tokens.push(new Token(centre[0], 10));
	this.tokens.push(new Token(centre[0], 3));
	this.tokens.push(new Token(centre[0], 3));
	this.tokens.push(new Token(topbit2, 10));
	this.tokens.push(new Token(topbit2, 5));
}

Level4.prototype = new Level();
