
function Node(x, y)
{
	this.pos = new Vector2(x, y);
	this.connections = new Array();
	this.barrier = null;
	this.enemy = null;
	this.from = null;
	this.flashtimes = new Array();
	this.alpha = 0;

	this.update = function()
	{
		if (this.alpha > 0)
		{
			if ((this.alpha -= 0.02) <= 0)
				this.alpha = 0;
		}

		for (var i = 0; i < this.flashtimes.length; i++)
		{
			if (this.flashtimes[i] == ticker)
			{
				this.flashtimes.splice(i--, 1);
				this.alpha = 1;
			}
		}
	}

	this.connectTo = function(n)
	{
		this.connections.push(n);
	}

	this.flashIn = function(time)
	{
		this.flashtimes.push(ticker + time);
	}

	this.render = function()
	{
		Global.render(Content.node, this.pos, 0, this.alpha);
	}
}
